#include "mthread_pthread.h"
#define NULL ((void*)0)
#define S 150
#define N 5

pthread_mutex_t  locks[N];
pthread_t        jobs[N];

unsigned int matrix[S];

unsigned int random();
unsigned int compute(int i, unsigned int prev);
int completed(unsigned int sum);

void * job( void * k ) {
  int i = (int) k ;

  while(1) {
    pthread_mutex_lock(locks+i);
    for(int j=i; j<S; j+=N)
      matrix[j] = compute(j, matrix[j]);
    pthread_mutex_unlock(locks+i);
  }
}

int main() {
  int i, j, sum;
  sum = 0;

  for(i=0;i<N;i++)
    pthread_mutex_init( &locks[i] , NULL);

  for(i=0;i<N;i++)
    pthread_create( &jobs[i], NULL, &job, (void *) i );

  while (!completed(sum)) {
    sum = 0;
    //@ loop pragma UNROLL N;
    for (i=0; i<N; i++) {
      pthread_mutex_lock(locks+i);
      int* pj = matrix+i;
      while(pj < matrix+S) {
        sum += *pj;
        pj += N;
      }
      pthread_mutex_unlock(locks+i);
    }
  }
  return 0;
}


/*
  while (!completed(sum)) {
    sum = 0;
    //@ loop pragma UNROLL N;
    for (j=0; j<S; j++) {
      i = j%N;
      pthread_mutex_lock(&locks[i]);
      sum += matrix[j];
      pthread_mutex_unlock(&locks[i]);
    }
*/
